diff --git a/Units/parser-cpreprocessor.r/backslash-in-parameters.d/args.ctags b/Units/parser-cpreprocessor.r/backslash-in-parameters.d/args.ctags
new file mode 100644
index 0000000000..7311baa956
--- /dev/null
+++ b/Units/parser-cpreprocessor.r/backslash-in-parameters.d/args.ctags
@@ -0,0 +1,2 @@
+--sort=no
+--fields=+S
diff --git a/Units/parser-cpreprocessor.r/backslash-in-parameters.d/expected.tags b/Units/parser-cpreprocessor.r/backslash-in-parameters.d/expected.tags
new file mode 100644
index 0000000000..7e5df512f3
--- /dev/null
+++ b/Units/parser-cpreprocessor.r/backslash-in-parameters.d/expected.tags
@@ -0,0 +1 @@
+IX_GET_BIT_FIELD16	input.h	/^#define IX_GET_BIT_FIELD16(/;"	d	signature:(arg_PackedData16,arg_FieldLSBBit,arg_FieldMSBBit)
diff --git a/Units/parser-cpreprocessor.r/backslash-in-parameters.d/input.h b/Units/parser-cpreprocessor.r/backslash-in-parameters.d/input.h
new file mode 100644
index 0000000000..923ea8e418
--- /dev/null
+++ b/Units/parser-cpreprocessor.r/backslash-in-parameters.d/input.h
@@ -0,0 +1,8 @@
+/* Taken from u-boot */
+#define IX_GET_BIT_FIELD16(					  \
+                            arg_PackedData16, \
+                            arg_FieldLSBBit, \
+                            arg_FieldMSBBit \
+                          ) \
+                          (((ix_uint16)(arg_PackedData16) & IX_BIT_FIELD_MASK16(arg_FieldLSBBit, arg_FieldMSBBit)) >> \
+                             arg_FieldLSBBit)
diff --git a/parsers/cpreprocessor.c b/parsers/cpreprocessor.c
index 1bebb16763..f55e5b8763 100644
--- a/parsers/cpreprocessor.c
+++ b/parsers/cpreprocessor.c
@@ -751,14 +751,17 @@ static int directiveDefine (const int c, bool undef)
 		readIdentifier (c, Cpp.directive.name);
 		if (! isIgnore ())
 		{
-			int p;
+			unsigned long 	lineNumber = getInputLineNumber ();
+			MIOPos filePosition = getInputFilePosition ();
+			int p = cppGetcFromUngetBufferOrFile ();
 
-			p = cppGetcFromUngetBufferOrFile ();
 			if (p == '(')
 			{
 				signature = vStringNewOrClearWithAutoRelease (signature);
 				do {
-					if (!isspacetab(p))
+					if (p == '\\')
+						cppGetcFromUngetBufferOrFile (); /* Throw away the next char */
+					else if (!isspacetab(p))
 						vStringPut (signature, p);
 					/* TODO: Macro parameters can be captured here. */
 					p = cppGetcFromUngetBufferOrFile ();
@@ -771,6 +774,13 @@ static int directiveDefine (const int c, bool undef)
 				}
 				else
 					r = makeDefineTag (vStringValue (Cpp.directive.name), NULL, undef);
+
+				if (r != CORK_NIL)
+				{
+					tagEntryInfo *e = getEntryInCorkQueue (r);
+					e->lineNumber = lineNumber;
+					e->filePosition = filePosition;
+				}
 			}
 			else
 			{
